import { CanActivate, CanDeactivate, Router, UrlTree, ActivatedRouteSnapshot } from '@angular/router';
import { Observable } from 'rxjs';
import { CollectionService } from './collection.service';
import { QueryFn } from '@angular/fire/firestore';
import { EntityState } from '@datorama/akita';
export interface CollectionRouteData {
    queryFn: QueryFn;
    redirect: string;
    awaitSync: boolean;
}
export declare function CollectionGuardConfig(data: Partial<CollectionRouteData>): (constructor: any) => void;
export declare class CollectionGuard<S extends EntityState<any> = any> implements CanActivate, CanDeactivate<any> {
    protected service: CollectionService<S>;
    private subscription;
    protected router: Router;
    constructor(service: CollectionService<S>);
    /** Should the guard wait for connection to Firestore to complete */
    protected readonly awaitSync: boolean;
    /** A queryFn to execute for sync */
    protected readonly queryFn: QueryFn;
    /** The route to redirect to if you sync failed */
    protected readonly redirect: string;
    /** The method to subscribe to while route is active */
    protected sync(next: ActivatedRouteSnapshot): Observable<any>;
    canActivate(next: ActivatedRouteSnapshot): Promise<boolean | UrlTree>;
    canDeactivate(): boolean;
}
